$(document).ready(function(){
	var h = getViewport().height;
	var w = getViewport().width;

	zoomToWindow();

	var pos = [];

	//get box positions and dimensions from css. 
	// note that ie6 doesn't take two class selection in css
	for (i=1; i<=9; i++) {
		var classLandscape = 'item'+i+'-landscape';
		var classPortrait = 'item'+i+'-portrait';
		//set position and scale as percentage for resizing later.
		var item = {
			className: 'item' + i,
			LTop: $('.' + classLandscape).position().top/h,
			LLeft: $('.' + classLandscape).position().left/w,
			LHeight: $('.' + classLandscape).height()/h,
			LWidth: $('.' + classLandscape).width()/w,
			PTop: $('.' + classPortrait).position().top/h,
			PLeft: $('.' + classPortrait).position().left/w,
			PHeight: $('.' + classPortrait).height()/h,
			PWidth: $('.' + classPortrait).width()/w
		};
		pos[i] = item;
	}
	$('.block.portrait').remove();

	//set original position	
	window.setTimeout(function(){
		displayInSpace(pos);
	},0);

	//set moving map	
	$('.item2').click(function(){
		if ($(".block").is(":animated")){ return; }
		$('.item2').boxMoveScale(pos[2],pos[7]);
		$('.item1').boxMoveScale(pos[1],pos[8]);
		$('.item3').boxMoveScale(pos[3],pos[9]);
		window.setTimeout(function(){
			$('.item7').slideText();
		},200);
	});

	$('.item3').click(function(){
		if ($(".block").is(":animated")){ return; }
		$('.item3').boxMoveScale(pos[3],pos[6]);
		$('.item1').boxMoveScale(pos[1],pos[4]);
		$('.item2').boxMoveScale(pos[2],pos[5]);
	});

	$('.item4').click(function(){
		if ($(".block").is(":animated")){ return; }
		$('.item4').boxMoveScale(pos[4],pos[1]);
		$('.item5').boxMoveScale(pos[5],pos[2]);
		$('.item6').boxMoveScale(pos[6],pos[3]);
	});

	$('.item5').click(function(){
		if ($(".block").is(":animated")){ return; }
		$('.item5').boxMoveScale(pos[5],pos[7]);
		$('.item6').boxMoveScale(pos[6],pos[9]);
		$('.item4').boxMoveScale(pos[4],pos[8]);
		window.setTimeout(function(){
			$('.item7').slideText();
		},200);
	});

	$('.item8').click(function(){
		if ($(".block").is(":animated")){ return; }
		$('.item8').boxMoveScale(pos[8],pos[1]);
		$('.item9').boxMoveScale(pos[9],pos[3]);
		$('.item7').boxMoveScale(pos[7],pos[2]);
	});

	$('.item9').click(function(){
		if ($(".block").is(":animated")){ return; }
		$('.item9').boxMoveScale(pos[9],pos[6]);
		$('.item7').boxMoveScale(pos[7],pos[5]);
		$('.item8').boxMoveScale(pos[8],pos[4]);
	});

	//observe window resizing and trigger redraw
    var needsRedraw = true;

    $(window).resize(function() {
        //if (isDesktop())
		needsRedraw=true;
    })

    setInterval(function() {
        if(needsRedraw){
			displayInSpace(pos);
            needsRedraw=false;
        }
    },100);

	//IE6 doesn't take png
	fixIE();

	window.pos = pos;
	window.needsRedraw = needsRedraw;

});

(function($){
	//zoom container to fill up viewport
	function zoomToWindow(){
		var css = {
			height: getViewport().height,
			width: getViewport().width
		};

		$('#container').css(css);
	}
	window.zoomToWindow = zoomToWindow;

	//observe device orientation change and trigger redraw
	function updateOrientation(){
		displayInSpace(pos);
		needsRedraw=false;
		
		//needsRedraw=true;
	}
	window.updateOrientation = updateOrientation;

	//function to detect ipad,iphone,itouch,etc.
	function isDesktop(){
		var deviceAgent = navigator.userAgent.toLowerCase();
		var notDesktop = deviceAgent.match(/(iphone|ipod|ipad|droid)/);
		return notDesktop ? false : true;
	}
	window.isDesktop = isDesktop;

	//function to display active blocks in space
	function displayInSpace(pos) {
		zoomToWindow();
		$('.block').hide();

		for (i=1; i<=9; i++) {
            var item = pos[i];
            $('.'+item.className).boxSetTo(item);

            if (isLandscape()) {
                $('.item'+i).removeClass('portrait item'+i+'-portrait').addClass('landscape item'+i+'-landscape');
            } else {
                $('.item'+i).removeClass('landscape item'+i+'-landscape').addClass('portrait item'+i+'-portrait');
            }
        };

		$('.active').show();

		$('video').videoHandler();

		/* ajust text left */
        if ($('.item7-portrait').hasClass('active') && isDesktop()) {
			var left = getViewport().height * 0.4;
			$('.item7 .text-area').css({'left':left});
		}
		return;
	}

	//expose displayInSpace
	window.displayInSpace = displayInSpace;

	// function that moves the box to position, and scale it relative to its container
	$.fn.boxMoveScale = function(from, to){
        var h = getViewport().height;
        var w = getViewport().width;
		var itemFrom = $('.'+from.className);
		var itemTo = $('.'+to.className);

		itemFrom.removeClass('active');
		itemTo.addClass('active');

		//for safari browsers, use webkit to transform.
		if (isLandscape()) 
		{
			//change the content, put the 'to' box to 'from' position and size.
			var css0 = {
				top : from.LTop*h,
				left : from.LLeft*w,
				height : from.LHeight*h,
				width : from.LWidth*w,
				opacity: 1,
				zIndex: 2,
				webkitTransform:"scale(0,0)"
			}
			if (to.LHeight < 0.5 || to.LWidth < 0.5) {
				css0.opacity=0;
				css0.zIndex=1;
			}
			var css = {
				top : to.LTop*h,
				left : to.LLeft*w,
				height : to.LHeight*h,
			width : to.LWidth*w,
				opacity: 1,
				webkitTransform:"scale(1,1)"
			}
		}
		else {
			//change the content, put the 'to' box to 'from' position and size.
			var css0 = {
				top : from.PTop*h,
				left : from.PLeft*w,
				height : from.PHeight*h,
				width : from.PWidth*w,
				opacity: 1,
				zIndex: 2,
				webkitTransform:"scale(0,0)"
			}
			if (to.LHeight < 0.5 || to.LWidth < 0.5) {
				css0.opacity=0;
				css0.zIndex=1;
			}
			var css = {
				top : to.PTop*h,
				left : to.PLeft*w,
				height : to.PHeight*h,
				width : to.PWidth*w,
				opacity: 1,
				webkitTransform:"scale(1,1)"
			}
		}

		if ($(itemFrom).hasClass('active')) {
			$(itemFrom.find('.video').remove());
		}

		$(itemFrom).hide();
		$(itemTo).find('img,video').hide();
		$(itemTo).css(css0).show();

		if ($.browser.safari) {
			//wait for css changes to finish before starting the webkit transform
			window.setTimeout(function(){
				$(itemTo).css(css0).css(css);
			}, 0);
		} else {
			//wait for css changes to finish before starting the webkit transform
			window.setTimeout(function(){
				$(itemTo).css(css0).animate(css, 1000);
			}, 0);
		}

		window.setTimeout(function(){
			$('img,video').show();
			
			if (isLandscape()) {
				$('.item7 img.portrait').hide();
			} else {
				$('.item7 img.landscape').hide();
			}
		},1000);

		return false;
	};

	// function that reset a box.
	$.fn.boxSetTo = function(item){
        var h = getViewport().height;
        var w = getViewport().width;

		if (isLandscape()) {
			var css = {
				'top': item.LTop * h,
				'left': item.LLeft * w,
				'height': item.LHeight * h,
				'width': item.LWidth * w,
                webkitTransform:"scale(1,1)"
			};
		} else {
			var css = {
				top: item.PTop * h,
				left: item.PLeft * w,
				height: item.PHeight * h,
				width: item.PWidth * w,
                webkitTransform:"scale(1,1)"
			};
		}

		$('.'+item.className).find('img,video').hide();
		window.setTimeout(function(){
			$('.'+item.className).css(css);
		},0);
		window.setTimeout(function(){
			$('.'+item.className).find('img,video').show();
			if (isLandscape()) {
				$('.item7 img.portrait').hide();
			} else {
				$('.item7 img.landscape').hide();
			}
		},1000);
	};

	function isLandscape() {
		return getViewport().width > getViewport().height;
	};
	window.isLandscape = isLandscape;

	// function that slide in text in "more" when activated
	$.fn.slideText = function(){
		var speed = 1500;

		$('.item7 .slide').hide().css({top: '120%', opacity: 0.1});
		$('.item7 .mask').css({opacity: 0.8});

		if ($.browser.msie && $.browser.version.substr(0,1)<7) {
			$('.mask').remove();
		}

		window.setTimeout(function(){
			$('.item7 .p1').show().animate({top:'13%', opacity: 1}, speed, function(){
 				$('.item7 .p2').show().animate({top:'35%', opacity: 1}, speed, function(){
					$('.item7 .p3').show().animate({top:'65%', opacity: 1}, speed);
				});
			});

			$('.item7 .mask1').delay(500).animate({opacity: 0}, speed, function(){
 				$('.item7 .mask2').animate({opacity: 0}, speed, function(){
					$('.item7 .mask3').animate({opacity: 0}, speed);
				});
			});
		},0);
		
		return false;
	}


	/* Apple disabled video autoplay on mobil safari for good reason. 
    We fake a button to force it autoplay here, some users may get charged in their 3G plans. */
	$.fn.videoHandler = function(){
		var $div = $('<a href="#" id="fakeClick">play</a>');
		$("body").append($div);

		$div.bind("click", function(e) {
			var video = $('video').get(0);
			video.play();
		});
		
		var evt, el = $("#fakeClick").get(0);

		if (document.createEvent) {
			evt = document.createEvent("MouseEvents");
			if (evt.initMouseEvent) {
				evt.initMouseEvent("click", true, true,window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
				el.dispatchEvent(evt);
			}
		}
		
		$(el).remove();
	}

	$.fn.playPause = function() {
		var myVideo = this;
		if (myVideo.paused)
			myVideo.play();
		else
			myVideo.pause();
	}

	function fixIE(){
		if ($.browser.msie && $.browser.version.substr(0,1)<7) {
			$('img.logo').attr('src', 'images/flipboard-logo.gif');
			$('img.ipad').attr('src', 'images/ipad-blank-landscape.gif');
		}
	}
	window.fixIE = fixIE;

	function getViewport(){
		var deviceAgent = navigator.userAgent.toLowerCase();
		var isGadget = deviceAgent.match(/(iphone|ipod|ipad|droid)/);

		if ($(window).width() < 800 || isGadget){
			var h = $(window).height();
			var w = $(window).width();
		} else {
			var h = Math.max($(window).height(), 768);
			var w = Math.max($(window).width(), 1024);
		}

		var v = {'height': h, 'width': w};
		return v;
	}
	window.getViewport = getViewport;

})(jQuery);


