$(document).ready(function(){
	var h = getViewport().height;
	var w = getViewport().width;

	zoomToWindow();

	var pos = [];

	//get box positions and dimensions from css. 
	for (i=1; i<=9; i++) {
		var classLandscape = 'item'+i+'-landscape';
		var classPortrait = 'item'+i+'-portrait';
		//set position and scale as percentage for resizing later.
		var item = {
			className: 'item' + i,
			LTop: $('.' + classLandscape).position().top/h,
			LLeft: $('.' + classLandscape).position().left/w,
			LHeight: $('.' + classLandscape).height()/h,
			LWidth: $('.' + classLandscape).width()/w,
			PTop: $('.' + classPortrait).position().top/h,
			PLeft: $('.' + classPortrait).position().left/w,
			PHeight: $('.' + classPortrait).height()/h,
			PWidth: $('.' + classPortrait).width()/w
		};
		pos[i] = item;
	}

	//set original position	
	displayInSpace(pos);

	//set moving map	
	$('.item2').click(function(){
		if ($(".block").is(":animated")){ return; }
		$('.item2').boxMoveScale(pos[2],pos[7]);
		$('.item1').boxMoveScale(pos[1],pos[8]);
		$('.item3').boxMoveScale(pos[3],pos[9]);
	});

	$('.item3').click(function(){
		if ($(".block").is(":animated")){ return; }
		$('.item3').boxMoveScale(pos[3],pos[6]);
		$('.item1').boxMoveScale(pos[1],pos[4]);
		$('.item2').boxMoveScale(pos[2],pos[5]);
	});

	$('.item4').click(function(){
		if ($(".block").is(":animated")){ return; }
		$('.item4').boxMoveScale(pos[4],pos[1]);
		$('.item5').boxMoveScale(pos[5],pos[2]);
		$('.item6').boxMoveScale(pos[6],pos[3]);
	});

	$('.item5').click(function(){
		if ($(".block").is(":animated")){ return; }
		$('.item5').boxMoveScale(pos[5],pos[7]);
		$('.item6').boxMoveScale(pos[6],pos[9]);
		$('.item4').boxMoveScale(pos[4],pos[8]);
	});

	$('.item8').click(function(){
		if ($(".block").is(":animated")){ return; }
		$('.item8').boxMoveScale(pos[8],pos[1]);
		$('.item9').boxMoveScale(pos[9],pos[3]);
		$('.item7').boxMoveScale(pos[7],pos[2]);
	});

	$('.item9').click(function(){
		if ($(".block").is(":animated")){ return; }
		$('.item9').boxMoveScale(pos[9],pos[6]);
		$('.item7').boxMoveScale(pos[7],pos[5]);
		$('.item8').boxMoveScale(pos[8],pos[4]);
	});

	//observe window resizing and trigger redraw
    var needsRedraw = true;
	var ready = true;

    $(window).resize(function() {
        if (isDesktop())
			needsRedraw=true;
    })

    setInterval(function() {
        if(needsRedraw){
			displayInSpace(pos);
            needsRedraw=false;
        }
    },100);

	//IE6 doesn't take png
	fixIE();

	window.pos = pos;
	window.ready = ready;
	window.needsRedraw = needsRedraw;
});

(function($){
	//zoom container to fill up viewport
	function zoomToWindow(){
		var css = {
			height: getViewport().height,
			width: getViewport().width
		};

		$('#container').css(css);
	}
	window.zoomToWindow = zoomToWindow;

	//observe device orientation change and trigger redraw
	function updateOrientation(){
		displayInSpace(pos);
        needsRedraw=false;
	}
	window.updateOrientation = updateOrientation;

	//function to detect ipad,iphone,itouch,etc.
	function isDesktop(){
		var deviceAgent = navigator.userAgent.toLowerCase();
		var notDesktop = deviceAgent.match(/(iphone|ipod|ipad)/);
		return notDesktop ? false : true;
	}
	window.isDesktop = isDesktop;

	//function to display active blocks in space
	function displayInSpace(pos) {
		zoomToWindow();
		for (i=1; i<=9; i++) {
			var item = pos[i];
			$('.'+item.className+'.landscape').boxSetTo(item);
			$('.'+item.className+'.portrait').boxSetTo(item);
		};

		$('.block').hide();
		if (isLandscape()) {
			$('.active').filter('.landscape').show();
		} else {
            $('.active').filter('.portrait').show();
		}

		/* ajust text left */
		var left = getViewport().height * 0.4;
		$('.item7 .text-area').css({'left':left});
	}

	//expose displayInSpace
	window.displayInSpace = displayInSpace;

	// function that moves the box to position, and scale it relative to its container
	$.fn.boxMoveScale = function(from, to){
        var h = getViewport().height;
        var w = getViewport().width;
		ready = false;

		$('.'+from.className).removeClass('active');
		$('.'+to.className).addClass('active');

		//for safari browsers, use webkit to transform.
		if (isLandscape()) 
		{
			var itemFrom = $('.'+from.className+'-landscape');
			var itemTo = $('.'+to.className+'-landscape');
			//change the content, put the 'to' box to 'from' position and size.
			var css0 = {
				top : from.LTop*h,
				left : from.LLeft*w,
				height : from.LHeight*h/5,
				width : from.LWidth*w/5,
				opacity: 0.8,
				zIndex: 2,
				webkitTransform:"scale(0,0)"
			}
			if (to.LHeight < 0.6 || to.LWidth < 0.6) {
				css0.opacity=0.2;
				css0.zIndex=1;
			}
			var css = {
				top : to.LTop*h,
				left : to.LLeft*w,
				height : to.LHeight*h,
			width : to.LWidth*w,
				opacity: 1,
				webkitTransform:"scale(1,1)"
			}
			$(itemFrom).hide();
			$(itemTo).find('img').hide();
			$(itemTo).css(css0).show();
		}
		else {
			var itemFrom = $('.'+from.className+'-portrait');
			var itemTo = $('.'+to.className+'-portrait');
			//change the content, put the 'to' box to 'from' position and size.
			var css0 = {
				top : from.PTop*h,
				left : from.PLeft*w,
				height : from.PHeight*h,
				width : from.PWidth*w,
				opacity: 1,
				zIndex: 2,
				webkitTransform:"scale(0,0)"
			}
			if (to.LHeight < 0.5 || to.LWidth < 0.5) {
				css0.opacity=0;
				css0.zIndex=1;
			}
			var css = {
				top : to.PTop*h,
				left : to.PLeft*w,
				height : to.PHeight*h,
				width : to.PWidth*w,
				opacity: 1,
				webkitTransform:"scale(1,1)"
			}
			$(itemFrom).hide();
			$(itemTo).find('img').hide();
			$(itemTo).css(css0).show();
		}

		if ($.browser.safari) {
			//wait for css changes to finish before starting the webkit transform
			window.setTimeout(function(){
				$(itemTo).css(css0).css(css);
			}, 0, function(){ready="true"});
		} else {
			//wait for css changes to finish before starting the webkit transform
			window.setTimeout(function(){
				$(itemTo).css(css0).animate(css, 1000);
			}, 0, function(){ready="true"});
		}

		window.setTimeout(function(){
			$('img').show();
		},1000);

		return false;
	};

	// function that reset a box.
	$.fn.boxSetTo = function(item){
        var h = getViewport().height;
        var w = getViewport().width;

		if (isLandscape()) {
			var css = {
				'top': item.LTop * h,
				'left': item.LLeft * w,
				'height': item.LHeight * h,
				'width': item.LWidth * w,
                webkitTransform:"scale(1,1)"
			};
		} else {
			var css = {
				top: item.PTop * h,
				left: item.PLeft * w,
				height: item.PHeight * h,
				width: item.PWidth * w,
                webkitTransform:"scale(1,1)"
			};
		}

		$('.'+item.className).find('img').hide();
		window.setTimeout(function(){
			$('.'+item.className).css(css);
		},0);
		window.setTimeout(function(){
			$('.'+item.className).find('img').show();
		},1000);
	};

	function isLandscape() {
		return getViewport().width > getViewport().height;
	};
	window.isLandscape = isLandscape;

	// function that slide in text in "more" when activated
	$.fn.slideText = function(){
		var speed = 1500;

		$('.item7 .slide').hide().css({top: '120%', opacity: 0.1});
		$('.item7 .mask').css({opacity: 0.8});

		if ($.browser.msie && $.browser.version.substr(0,1)<7) {
			$('.mask').remove();
		}

		window.setTimeout(function(){
			$('.item7 .p1').show().animate({top:'13%', opacity: 1}, speed, function(){
 				$('.item7 .p2').show().animate({top:'35%', opacity: 1}, speed, function(){
					$('.item7 .p3').show().animate({top:'65%', opacity: 1}, speed);
				});
			});

			$('.item7 .mask1').animate({opacity: 0}, speed, function(){
 				$('.item7 .mask2').animate({opacity: 0}, speed, function(){
					$('.item7 .mask3').animate({opacity: 0}, speed);
				});
			});
		},0);
		
		return false;
	}

	function getViewport(){
		var deviceAgent = navigator.userAgent.toLowerCase();
		var isGadget = deviceAgent.match(/(iphone|ipod|ipad|droid)/);

		if (isGadget) {
			var h = window.innerHeight;
			var w = window.innerWidth;
		} else {
			var h = Math.max($(window).height(),768);
			var w = Math.max($(window).width(), 1024);
		}

		var v = {'height': h, 'width': w};
		return v;
	}
	window.getViewport = getViewport;

	function fixIE(){
		if ($.browser.msie && $.browser.version.substr(0,1)<7) {
			$('img.logo').attr('src', 'images/flipboard-logo.gif');
			$('img.ipad').attr('src', 'images/ipad-blank.gif');
		}
	}
	window.fixIE = fixIE;
})(jQuery);


