
$(document).ready(function(){

	var container = $('#container');

	var item1 = {
		className: 'item1',
		LTop: 0, 
		LLeft: 0, 
		LHeight: 0.75, 
		LWidth: 1,
		PTop: 0, 
		PLeft: 0, 
		PHeight: 0.75, 
		PWidth: 1
	};
	var item2 = {
		className: 'item2',
		LTop: 0.75, 
		LLeft: 0, 
		LHeight: 0.25, 
		LWidth: 0.5,
        PTop: 0.75,
        PLeft: 0,
        PHeight: 0.25,
        PWidth: 0.5
	};
	var item3 = {
		className: 'item3',
		LTop: 0.75, 
		LLeft: 0.5, 
		LHeight: 0.25, 
		LWidth: 0.5,
        PTop: 0.75,
        PLeft: 0.5,
        PHeight: 0.25,
        PWidth: -1.5
	};
	var item4 = {
		className: 'item4',
		LTop: 0,
		LLeft: 0,
		LHeight: 0.33,
		LWidth: 0.2,
        PTop: 0.62,
        PLeft: 0,
        PHeight: 0.38,
        PWidth: 0.5
	};
	var item5 = {
		className: 'item5',
		LTop: 0.33,
		LLeft: 0,
		LHeight: 0.67,
		LWidth: 0.2,
        PTop: 0.62,
        PLeft: 0.5,
        PHeight: 0.38,
        PWidth: 0.2
	};
	var item6 = {
		className: 'item6',
		LTop: 0,
		LLeft: 0.2,
		LHeight: 1,
		LWidth: 0.8,
        PTop: 0,
        PLeft: 0,
        PHeight: 0.62,
        PWidth: 1
	};
	var item7 = {
		className: 'item7',
		LTop: 0,
		LLeft: 0,
		LHeight: 1,
		LWidth: 0.7,
        PTop: 0,
        PLeft: 0,
        PHeight: 1,
        PWidth: 0.751
	};
	var item8 = {
		className: 'item8',
		LTop: 0,
		LLeft: 0.7,
		LHeight: 0.5,
		LWidth: 0.3,
        PTop: 0,
        PLeft: 0.751,
        PHeight: 0.186,
        PWidth: 0.249
	};
	var item9 = {
		className: 'item9',
		LTop: 0.5,
		LLeft: 0.7,
		LHeight: 0.5,
		LWidth: 0.3,
        PTop: 0.186,
        PLeft: 0.751,
        PHeight: 0.814,
        PWidth: 0.249
	};

	var list= [item1,item2,item3,item4,item5,item6,item7,item8,item9];


	//set original position	
	displayInSpace(list, container);

	//set moving map	
	$('.item2').click(function(){
		$('.item2').boxMoveScale(item2,item7);
		$('.item1').boxMoveScale(item1,item8);
		$('.item3').boxMoveScale(item3,item9);
	});

	$('.item3').click(function(){
		$('.item3').boxMoveScale(item3,item6);
		$('.item1').boxMoveScale(item1,item4);
		$('.item2').boxMoveScale(item2,item5);
	});

	$('.item4').click(function(){
		$('.item4').boxMoveScale(item4,item1);
		$('.item5').boxMoveScale(item5,item2);
		$('.item6').boxMoveScale(item6,item3);
	});

	$('.item5').click(function(){
		$('.item5').boxMoveScale(item5,item7);
		$('.item6').boxMoveScale(item6,item9);
		$('.item4').boxMoveScale(item4,item8);
	});

	$('.item8').click(function(){
		$('.item8').boxMoveScale(item8,item1);
		$('.item9').boxMoveScale(item9,item3);
		$('.item7').boxMoveScale(item7,item2);
	});

	$('.item9').click(function(){
		$('.item9').boxMoveScale(item9,item6);
		$('.item7').boxMoveScale(item7,item5);
		$('.item8').boxMoveScale(item8,item4);
	});

	//observe window resizing and trigger redraw
    var needsRedraw = true;

    setInterval(function() {
        if(needsRedraw){
			displayInSpace(list, container);
            needsRedraw=false;
        }
    },100);

	window.list = list;
	window.container = container;
	window.needsRedraw = needsRedraw;
});

(function($){
	function updateOrientation(){
		displayInSpace(list, container);
		needsRedraw=false;
	}
	window.updateOrientation = updateOrientation;

	$.fn.zoomToWindow = function() {
		if ($(window).width() < 1024) {
			var h = $(window).height();
			var w = $(window).width();
		}
		else {
			var h = $('#container').height;
			var w = $('#container').width;
		}

		$(this).css({'height': h, 'width': w});
	}
	//function to adjust display by seting boxes in place
	function displayInSpace(list, container) {
		container.zoomToWindow();

		// IE doesn't take forEach(), each(), map()
        for (i=0; i<9; i++) {
			var item = list[i];
			$('.'+item.className).boxSetTo(item);
		};
		container.find('div.active').show();
	}
	//expose displayInSpace
	window.displayInSpace = displayInSpace;

	// function that moves the box to position, and scale it relative to its container
	$.fn.boxMoveScale = function(from, to){
		if (window.orientation == '90' | window.orientation == '-90')
		{
			var top0 = $(this).parent().height() * from.LTop;
			var left0 = $(this).parent().width() * from.LLeft;
			var height0 = $(this).parent().height() * from.LHeight;
			var width0 = $(this).parent().width() * from.LWidth;
			var class0 = from.className;
			
			var top = $(this).parent().height() * to.LTop;
			var left = $(this).parent().width() * to.LLeft;
			var height = $(this).parent().height() * to.LHeight;
			var width = $(this).parent().width() * to.LWidth;
		}
		else {
			var top0 = $(this).parent().height() * from.PTop;
			var left0 = $(this).parent().width() * from.PLeft;
			var height0 = $(this).parent().height() * from.PHeight;
			var width0 = $(this).parent().width() * from.PWidth;
			var class0 = from.className;
			
			var top = $(this).parent().height() * to.PTop;
			var left = $(this).parent().width() * to.PLeft;
			var height = $(this).parent().height() * to.PHeight;
			var width = $(this).parent().width() * to.PWidth;
		}

		if ($.browser.webkit) {
			//change content then transform
			$(this).hide();

			$('.'+to.className).css({
				top : top0,
				left : left0,
				height : height0,
				width : width0
			}).show();
			
			var a = function(){
				$('.'+to.className).css({
					top : top,
					left : left,
					height : height,
					width : width,
					transform : "scale(1,1)"
				}).show();
			}
			
			window.setTimeout(a, 0);
		}
		else {		
			$(this).animate({
				top : top,
				left : left,
				height : height,
				width : width,
				fps: 20,
				no_of_frames: 20
			},500, function(){
				$('.'+to.className).show().addClass('active');
				$(this).hide().removeClass('active').css({
					'top': top0, 
					'left': left0, 
					'height': height0, 
					'width': width0
				});
			});
		}
/*
            //transform then change content
			$('.'+from.className).css({
				top : top,
				left : left,
				height : height,
				width : width,
				zIndex : 2,
				transform : "scale(1,1)"
			});

			var a = function(){
				$('.'+from.className).hide();
				$('.'+to.className).show();
			}
			window.setTimeout(a, 500);

			var b = function(){
				$('.'+from.className).css({
					top : top0,
					left : left0,
					height : height0,
					width : width0,
				});
			}
			window.setTimeout(b, 1000);
*/			
		return false;
	};
	// function that set the box.
	$.fn.boxSetTo = function(pos){
		//set box to position and scale in relative to its container
		var top = $(this).parent().height() * pos.LTop;
		var left = $(this).parent().width() * pos.LLeft;
		var height = $(this).parent().height() * pos.LHeight;
		var width = $(this).parent().width() * pos.LWidth;
		$(this).css({
			'top': top, 
			'left' : left, 
			'width' : width, 
			'height' : height
		});

		$(this).hide();
		return false;
	};

	$.fn.isLandscape = function() {
		return this.width >= this.height;
	};

	$.fn.fullscreenr = function() {
		// Scale the container
		$(this).height($(window).height());
		$(this).width($(window).width());
		return this; 
	};
})(jQuery);


